## xen-source-2.6.16 2.6.16-11.2

=== Makefile ===
VERSION = 2
PATCHLEVEL = 6
SUBLEVEL = 16
EXTRAVERSION = 
NAME=Stable Penguin

# *DOCUMENTATION*
# To see a list of typical targets execute "make help"
# More info can be located in ./README
# Comments in this file are targeted only to the developer, do not
# expect to learn how to build the kernel reading this file.

# Do not print "Entering directory ..."
MAKEFLAGS += --no-print-directory

# We are using a recursive build, so we need to do a little thinking
# to get the ordering right.
#
# Most importantly: sub-Makefiles should only ever modify files in
# their own directory. If in some directory we have a dependency on
# a file in another dir (which doesn't happen often, but it's often
# unavoidable when linking the built-in.o targets which finally
# turn into vmlinux), we will call a sub make in that other dir, and
# after that we are sure that everything which is in that other dir
# is now up to date.
#
# The only cases where we need to modify files which have global
# effects are thus separated out and done before the recursive
# descending is started. They are now explicitly listed as the
# prepare rule.

# To put more focus on warnings, be less verbose as default
# Use 'make V=1' to see the full commands

ifdef V
  ifeq ("$(origin V)", "command line")
    KBUILD_VERBOSE = $(V)
  endif
endif
ifndef KBUILD_VERBOSE
  KBUILD_VERBOSE = 0
endif

# Call sparse as part of compilation of C files
# Use 'make C=1' to enable sparse checking

ifdef C
  ifeq ("$(origin C)", "command line")
    KBUILD_CHECKSRC = $(C)
  endif
endif
ifndef KBUILD_CHECKSRC
  KBUILD_CHECKSRC = 0
endif

# Use make M=dir to specify directory of external module to build
# Old syntax make ... SUBDIRS=$PWD is still supported
# Setting the environment variable KBUILD_EXTMOD take precedence
ifdef SUBDIRS
  KBUILD_EXTMOD ?= $(SUBDIRS)
endif
ifdef M
  ifeq ("$(origin M)", "command line")
    KBUILD_EXTMOD := $(M)
  endif
endif


# kbuild supports saving output files in a separate directory.
# To locate output files in a separate directory two syntaxes are supported.
# In both cases the working directory must be the root of the kernel src.
# 1) O=
# Use "make O=dir/to/store/output/files/"
# 
# 2) Set KBUILD_OUTPUT
# Set the environment variable KBUILD_OUTPUT to point to the directory
# where the output files shall be placed.
# export KBUILD_OUTPUT=dir/to/store/output/files/
# make
#
# The O= assignment takes precedence over the KBUILD_OUTPUT environment
# variable.


# KBUILD_SRC is set on invocation of make in OBJ directory
# KBUILD_SRC is not intended to be used by the regular user (for now)
ifeq ($(KBUILD_SRC),)

# OK, Make called in directory where kernel src resides
# Do we want to locate output files in a separate directory?
ifdef O
  ifeq ("$(origin O)", "command line")
    KBUILD_OUTPUT := $(O)
  endif
endif

# That's our default target when none is given on the command line
.PHONY: _all
_all:

ifneq ($(KBUILD_OUTPUT),)
# Invoke a second make in the output directory, passing relevant variables
# check that the output directory actually exists
saved-output := $(KBUILD_OUTPUT)
KBUILD_OUTPUT := $(shell cd $(KBUILD_OUTPUT) && /bin/pwd)
$(if $(KBUILD_OUTPUT),, \
     $(error output directory "$(saved-output)" does not exist))

.PHONY: $(MAKECMDGOALS)

$(filter-out _all,$(MAKECMDGOALS)) _all:
	$(if $(KBUILD_VERBOSE:1=),@)$(MAKE) -C $(KBUILD_OUTPUT) \
	KBUILD_SRC=$(CURDIR) \
	KBUILD_EXTMOD="$(KBUILD_EXTMOD)" -f $(CURDIR)/Makefile $@

# Leave processing to above invocation of make
skip-makefile := 1
endif # ifneq ($(KBUILD_OUTPUT),)
endif # ifeq ($(KBUILD_SRC),)

# We process the rest of the Makefile if this is the final invocation of make
ifeq ($(skip-makefile),)

# If building an external module we do not care about the all: rule
# but instead _all depend on modules
.PHONY: all
ifeq ($(KBUILD_EXTMOD),)
_all: all
else
_all: modules
endif

srctree		:= $(if $(KBUILD_SRC),$(KBUILD_SRC),$(CURDIR))
TOPDIR		:= $(srctree)
# FIXME - TOPDIR is obsolete, use srctree/objtree
objtree		:= $(CURDIR)
src		:= $(srctree)
obj		:= $(objtree)

VPATH		:= $(srctree)

export srctree objtree VPATH TOPDIR


# SUBARCH tells the usermode build what the underlying arch is.  That is set
# first, and if a usermode build is happening, the "ARCH=um" on the command
# line overrides the setting of ARCH below.  If a native build is happening,
# then ARCH is assigned, getting whatever value it gets normally, and 
# SUBARCH is subsequently ignored.

SUBARCH := $(shell uname -m | sed -e s/i.86/i386/ -e s/sun4u/sparc64/ \
				  -e s/arm.*/arm/ -e s/sa110/arm/ \
				  -e s/s390x/s390/ -e s/parisc64/parisc/ \
				  -e s/ppc.*/powerpc/ )

# Cross compiling and selecting different set of gcc/bin-utils
# ---------------------------------------------------------------------------
#
# When performing cross compilation for other architectures ARCH shall be set
# to the target architecture. (See arch/* for the possibilities).
# ARCH can be set during invocation of make:
# make ARCH=ia64
# Another way is to have ARCH set in the environment.
# The default ARCH is the host where make is executed.

# CROSS_COMPILE specify the prefix used for all executables used
# during compilation. Only gcc and related bin-utils executables
# are prefixed with $(CROSS_COMPILE).
# CROSS_COMPILE can be set on the command line
# make CROSS_COMPILE=ia64-linux-
# Alternatively CROSS_COMPILE can be set in the environment.
# Default value for CROSS_COMPILE is not to prefix executables
# Note: Some architectures assign CROSS_COMPILE in their arch/*/Makefile

ARCH		?= $(SUBARCH)
CROSS_COMPILE	?=

# Architecture as present in compile.h
UTS_MACHINE := $(ARCH)

# SHELL used by kbuild
CONFIG_SHELL := $(shell if [ -x "$$BASH" ]; then echo $$BASH; \
	  else if [ -x /bin/bash ]; then echo /bin/bash; \
	  else echo sh; fi ; fi)

HOSTCC  	= gcc
HOSTCXX  	= g++
HOSTCFLAGS	= -Wall -Wstrict-prototypes -O2 -fomit-frame-pointer
HOSTCXXFLAGS	= -O2

# 	Decide whether to build built-in, modular, or both.
#	Normally, just do built-in.

KBUILD_MODULES :=
KBUILD_BUILTIN := 1

#	If we have only "make modules", don't compile built-in objects.
#	When we're building modules with modversions, we need to consider
#	the built-in objects during the descend as well, in order to
#	make sure the checksums are uptodate before we record them.

ifeq ($(MAKECMDGOALS),modules)
  KBUILD_BUILTIN := $(if $(CONFIG_MODVERSIONS),1)
endif

#	If we have "make <whatever> modules", compile modules
#	in addition to whatever we do anyway.
#	Just "make" or "make all" shall build modules as well

ifneq ($(filter all _all modules,$(MAKECMDGOALS)),)
  KBUILD_MODULES := 1
endif

ifeq ($(MAKECMDGOALS),)
  KBUILD_MODULES := 1
endif

export KBUILD_MODULES KBUILD_BUILTIN
export KBUILD_CHECKSRC KBUILD_SRC KBUILD_EXTMOD

# Beautify output
# ---------------------------------------------------------------------------
#
# Normally, we echo the whole command before executing it. By making
# that echo $($(quiet)$(cmd)), we now have the possibility to set
# $(quiet) to choose other forms of output instead, e.g.
#
#         quiet_cmd_cc_o_c = Compiling $(RELDIR)/$@
#         cmd_cc_o_c       = $(CC) $(c_flags) -c -o $@ $<
#
# If $(quiet) is empty, the whole command will be printed.
# If it is set to "quiet_", only the short version will be printed. 
# If it is set to "silent_", nothing wil be printed at all, since
# the variable $(silent_cmd_cc_o_c) doesn't exist.
#
# A simple variant is to prefix commands with $(Q) - that's useful
# for commands that shall be hidden in non-verbose mode.
#
#	$(Q)ln $@ :<
#
# If KBUILD_VERBOSE equals 0 then the above command will be hidden.
# If KBUILD_VERBOSE equals 1 then the above command is displayed.

ifeq ($(KBUILD_VERBOSE),1)
  quiet =
  Q =
else
  quiet=quiet_
  Q = @
endif

# If the user is running make -s (silent mode), suppress echoing of
# commands

ifneq ($(findstring s,$(MAKEFLAGS)),)
  quiet=silent_
endif

export quiet Q KBUILD_VERBOSE

######
# cc support functions to be used (only) in arch/$(ARCH)/Makefile
# See documentation in Documentation/kbuild/makefiles.txt

# as-option
# Usage: cflags-y += $(call as-option, -Wa$(comma)-isa=foo,)

as-option = $(shell if $(CC) $(CFLAGS) $(1) -Wa,-Z -c -o /dev/null \
	     -xassembler /dev/null > /dev/null 2>&1; then echo "$(1)"; \
	     else echo "$(2)"; fi ;)

# cc-option
# Usage: cflags-y += $(call cc-option, -march=winchip-c6, -march=i586)

cc-option = $(shell if $(CC) $(CFLAGS) $(1) -S -o /dev/null -xc /dev/null \
             > /dev/null 2>&1; then echo "$(1)"; else echo "$(2)"; fi ;)

# cc-option-yn
# Usage: flag := $(call cc-option-yn, -march=winchip-c6)
cc-option-yn = $(shell if $(CC) $(CFLAGS) $(1) -S -o /dev/null -xc /dev/null \
                > /dev/null 2>&1; then echo "y"; else echo "n"; fi;)

# cc-option-align
# Prefix align with either -falign or -malign
cc-option-align = $(subst -functions=0,,\
	$(call cc-option,-falign-functions=0,-malign-functions=0))

# cc-version
# Usage gcc-ver := $(call cc-version $(CC))
cc-version = $(shell $(CONFIG_SHELL) $(srctree)/scripts/gcc-version.sh \
              $(if $(1), $(1), $(CC)))


# Look for make include files relative to root of kernel src
MAKEFLAGS += --include-dir=$(srctree)

# We need some generic definitions
include  $(srctree)/scripts/Kbuild.include

# For maximum performance (+ possibly random breakage, uncomment
# the following)

#MAKEFLAGS += -rR

# Make variables (CC, etc...)

AS		= $(CROSS_COMPILE)as
LD		= $(CROSS_COMPILE)ld
CC		= $(CROSS_COMPILE)gcc
CPP		= $(CC) -E
AR		= $(CROSS_COMPILE)ar
NM		= $(CROSS_COMPILE)nm
STRIP		= $(CROSS_COMPILE)strip
OBJCOPY		= $(CROSS_COMPILE)objcopy
OBJDUMP		= $(CROSS_COMPILE)objdump
AWK		= awk
GENKSYMS	= scripts/genksyms/genksyms
DEPMOD		= /sbin/depmod
KALLSYMS	= scripts/kallsyms
PERL		= perl
CHECK		= sparse

CHECKFLAGS     := -D__linux__ -Dlinux -D__STDC__ -Dunix -D__unix__ -Wbitwise $(CF)
MODFLAGS	= -DMODULE
CFLAGS_MODULE   = $(MODFLAGS)
AFLAGS_MODULE   = $(MODFLAGS)
LDFLAGS_MODULE  = -r
CFLAGS_KERNEL	=
AFLAGS_KERNEL	=


# Use LINUXINCLUDE when you must reference the include/ directory.
# Needed to be compatible with the O= option
LINUXINCLUDE    := -Iinclude \
                   $(if $(KBUILD_SRC),-Iinclude2 -I$(srctree)/include) \
		   -include include/linux/autoconf.h

CPPFLAGS        := -D__KERNEL__ $(LINUXINCLUDE)

CFLAGS 		:= -Wall -Wundef -Wstrict-prototypes -Wno-trigraphs \
	  	   -fno-strict-aliasing -fno-common \
		   -ffreestanding -fno-stack-protector
AFLAGS		:= -D__ASSEMBLY__

# Read KERNELRELEASE from .kernelrelease (if it exists)
KERNELRELEASE = $(shell cat .kernelrelease 2> /dev/null)
KERNELVERSION = $(VERSION).$(PATCHLEVEL).$(SUBLEVEL)$(EXTRAVERSION)

export	VERSION PATCHLEVEL SUBLEVEL KERNELRELEASE KERNELVERSION \
	ARCH CONFIG_SHELL HOSTCC HOSTCFLAGS CROSS_COMPILE AS LD CC \
	CPP AR NM STRIP OBJCOPY OBJDUMP MAKE AWK GENKSYMS PERL UTS_MACHINE \
	HOSTCXX HOSTCXXFLAGS LDFLAGS_MODULE CHECK CHECKFLAGS

export CPPFLAGS NOSTDINC_FLAGS LINUXINCLUDE OBJCOPYFLAGS LDFLAGS
export CFLAGS CFLAGS_KERNEL CFLAGS_MODULE 
export AFLAGS AFLAGS_KERNEL AFLAGS_MODULE

# When compiling out-of-tree modules, put MODVERDIR in the module
# tree rather than in the kernel tree. The kernel tree might
# even be read-only.
export MODVERDIR := $(if $(KBUILD_EXTMOD),$(firstword $(KBUILD_EXTMOD))/).tmp_versions

# Files to ignore in find ... statements

RCS_FIND_IGNORE := \( -name SCCS -o -name BitKeeper -o -name .svn -o -name CVS -o -name .pc -o -name .hg -o -name .git \) -prune -o
export RCS_TAR_IGNORE := --exclude SCCS --exclude BitKeeper --exclude .svn --exclude CVS --exclude .pc --exclude .hg --exclude .git

# ===========================================================================
# Rules shared between *config targets and build targets

# Basic helpers built in scripts/
.PHONY: scripts_basic
scripts_basic:
	$(Q)$(MAKE) $(build)=scripts/basic

# To avoid any implicit rule to kick in, define an empty command.
scripts/basic/%: scripts_basic ;

.PHONY: outputmakefile

=== drivers/net/Makefile ===
#
# Makefile for the Linux network (ethercard) device drivers.
#

ifeq ($(CONFIG_ISDN_PPP),y)
  obj-$(CONFIG_ISDN) += slhc.o
endif

obj-$(CONFIG_E1000) += e1000/
obj-$(CONFIG_IBM_EMAC) += ibm_emac/
obj-$(CONFIG_IXGB) += ixgb/
obj-$(CONFIG_CHELSIO_T1) += chelsio/
obj-$(CONFIG_BONDING) += bonding/
obj-$(CONFIG_GIANFAR) += gianfar_driver.o

gianfar_driver-objs := gianfar.o \
		gianfar_ethtool.o \
		gianfar_mii.o \
		gianfar_sysfs.o

#
# link order important here
#
obj-$(CONFIG_PLIP) += plip.o

obj-$(CONFIG_ROADRUNNER) += rrunner.o

obj-$(CONFIG_HAPPYMEAL) += sunhme.o
obj-$(CONFIG_SUNLANCE) += sunlance.o
obj-$(CONFIG_SUNQE) += sunqe.o
obj-$(CONFIG_SUNBMAC) += sunbmac.o
obj-$(CONFIG_MYRI_SBUS) += myri_sbus.o
obj-$(CONFIG_SUNGEM) += sungem.o sungem_phy.o
obj-$(CONFIG_CASSINI) += cassini.o

obj-$(CONFIG_MACE) += mace.o
obj-$(CONFIG_BMAC) += bmac.o

obj-$(CONFIG_OAKNET) += oaknet.o 8390.o

obj-$(CONFIG_DGRS) += dgrs.o
obj-$(CONFIG_VORTEX) += 3c59x.o
obj-$(CONFIG_TYPHOON) += typhoon.o
obj-$(CONFIG_NE2K_PCI) += ne2k-pci.o 8390.o
obj-$(CONFIG_PCNET32) += pcnet32.o
obj-$(CONFIG_EEPRO100) += eepro100.o
obj-$(CONFIG_E100) += e100.o
obj-$(CONFIG_TLAN) += tlan.o
obj-$(CONFIG_EPIC100) += epic100.o
obj-$(CONFIG_SIS190) += sis190.o
obj-$(CONFIG_SIS900) += sis900.o
obj-$(CONFIG_YELLOWFIN) += yellowfin.o
obj-$(CONFIG_ACENIC) += acenic.o
obj-$(CONFIG_ISERIES_VETH) += iseries_veth.o
obj-$(CONFIG_NATSEMI) += natsemi.o
obj-$(CONFIG_NS83820) += ns83820.o
obj-$(CONFIG_STNIC) += stnic.o 8390.o
obj-$(CONFIG_FEALNX) += fealnx.o
obj-$(CONFIG_TIGON3) += tg3.o
obj-$(CONFIG_BNX2) += bnx2.o
spidernet-y += spider_net.o spider_net_ethtool.o sungem_phy.o
obj-$(CONFIG_SPIDER_NET) += spidernet.o
obj-$(CONFIG_TC35815) += tc35815.o
obj-$(CONFIG_SKGE) += skge.o
obj-$(CONFIG_SKY2) += sky2.o
obj-$(CONFIG_SK98LIN) += sk98lin/
obj-$(CONFIG_SKFP) += skfp/
obj-$(CONFIG_VIA_RHINE) += via-rhine.o
obj-$(CONFIG_VIA_VELOCITY) += via-velocity.o
obj-$(CONFIG_ADAPTEC_STARFIRE) += starfire.o
obj-$(CONFIG_RIONET) += rionet.o

#
# end link order section
#

obj-$(CONFIG_MII) += mii.o
obj-$(CONFIG_PHYLIB) += phy/

obj-$(CONFIG_SUNDANCE) += sundance.o
obj-$(CONFIG_HAMACHI) += hamachi.o
obj-$(CONFIG_NET) += Space.o loopback.o
obj-$(CONFIG_SEEQ8005) += seeq8005.o
obj-$(CONFIG_NET_SB1000) += sb1000.o
obj-$(CONFIG_MAC8390) += mac8390.o 8390.o
obj-$(CONFIG_APNE) += apne.o 8390.o
obj-$(CONFIG_PCMCIA_PCNET) += 8390.o
obj-$(CONFIG_SHAPER) += shaper.o
obj-$(CONFIG_HP100) += hp100.o
obj-$(CONFIG_SMC9194) += smc9194.o
obj-$(CONFIG_FEC) += fec.o
obj-$(CONFIG_68360_ENET) += 68360enet.o
obj-$(CONFIG_ARM_ETHERH) += 8390.o
obj-$(CONFIG_WD80x3) += wd.o 8390.o
obj-$(CONFIG_EL2) += 3c503.o 8390.o
obj-$(CONFIG_NE2000) += ne.o 8390.o
obj-$(CONFIG_NE2_MCA) += ne2.o 8390.o
obj-$(CONFIG_HPLAN) += hp.o 8390.o
obj-$(CONFIG_HPLAN_PLUS) += hp-plus.o 8390.o
obj-$(CONFIG_ULTRA) += smc-ultra.o 8390.o
obj-$(CONFIG_ULTRAMCA) += smc-mca.o 8390.o
obj-$(CONFIG_ULTRA32) += smc-ultra32.o 8390.o
obj-$(CONFIG_E2100) += e2100.o 8390.o
obj-$(CONFIG_ES3210) += es3210.o 8390.o
obj-$(CONFIG_LNE390) += lne390.o 8390.o
obj-$(CONFIG_NE3210) += ne3210.o 8390.o
obj-$(CONFIG_NET_SB1250_MAC) += sb1250-mac.o
obj-$(CONFIG_B44) += b44.o
obj-$(CONFIG_FORCEDETH) += forcedeth.o
obj-$(CONFIG_NE_H8300) += ne-h8300.o 8390.o

obj-$(CONFIG_MV643XX_ETH) += mv643xx_eth.o

obj-$(CONFIG_PPP) += ppp_generic.o slhc.o
obj-$(CONFIG_PPP_ASYNC) += ppp_async.o
obj-$(CONFIG_PPP_SYNC_TTY) += ppp_synctty.o
obj-$(CONFIG_PPP_DEFLATE) += ppp_deflate.o
obj-$(CONFIG_PPP_BSDCOMP) += bsd_comp.o
obj-$(CONFIG_PPP_MPPE) += ppp_mppe.o
obj-$(CONFIG_PPPOE) += pppox.o pppoe.o

obj-$(CONFIG_SLIP) += slip.o
ifeq ($(CONFIG_SLIP_COMPRESSED),y)
  obj-$(CONFIG_SLIP) += slhc.o
endif

obj-$(CONFIG_DUMMY) += dummy.o
obj-$(CONFIG_IFB) += ifb.o
obj-$(CONFIG_DE600) += de600.o
obj-$(CONFIG_DE620) += de620.o
obj-$(CONFIG_LANCE) += lance.o
obj-$(CONFIG_SUN3_82586) += sun3_82586.o
obj-$(CONFIG_SUN3LANCE) += sun3lance.o
obj-$(CONFIG_DEFXX) += defxx.o
obj-$(CONFIG_SGISEEQ) += sgiseeq.o
obj-$(CONFIG_SGI_O2MACE_ETH) += meth.o
obj-$(CONFIG_AT1700) += at1700.o
obj-$(CONFIG_EL1) += 3c501.o
obj-$(CONFIG_EL16) += 3c507.o
obj-$(CONFIG_ELMC) += 3c523.o
obj-$(CONFIG_SKMC) += sk_mca.o
obj-$(CONFIG_IBMLANA) += ibmlana.o
obj-$(CONFIG_ELMC_II) += 3c527.o
obj-$(CONFIG_EL3) += 3c509.o
obj-$(CONFIG_3C515) += 3c515.o
obj-$(CONFIG_EEXPRESS) += eexpress.o
obj-$(CONFIG_EEXPRESS_PRO) += eepro.o
obj-$(CONFIG_8139CP) += 8139cp.o
obj-$(CONFIG_8139TOO) += 8139too.o
obj-$(CONFIG_ZNET) += znet.o
obj-$(CONFIG_LAN_SAA9730) += saa9730.o
obj-$(CONFIG_DEPCA) += depca.o
obj-$(CONFIG_EWRK3) += ewrk3.o
obj-$(CONFIG_ATP) += atp.o
obj-$(CONFIG_NI5010) += ni5010.o
obj-$(CONFIG_NI52) += ni52.o
obj-$(CONFIG_NI65) += ni65.o
obj-$(CONFIG_ELPLUS) += 3c505.o
obj-$(CONFIG_AC3200) += ac3200.o 8390.o
obj-$(CONFIG_APRICOT) += 82596.o
obj-$(CONFIG_LASI_82596) += lasi_82596.o
obj-$(CONFIG_MVME16x_NET) += 82596.o
obj-$(CONFIG_BVME6000_NET) += 82596.o

# This is also a 82596 and should probably be merged
obj-$(CONFIG_LP486E) += lp486e.o

obj-$(CONFIG_ETH16I) += eth16i.o
obj-$(CONFIG_ZORRO8390) += zorro8390.o 8390.o
obj-$(CONFIG_HPLANCE) += hplance.o 7990.o
obj-$(CONFIG_MVME147_NET) += mvme147.o 7990.o
obj-$(CONFIG_EQUALIZER) += eql.o
obj-$(CONFIG_MIPS_JAZZ_SONIC) += jazzsonic.o
obj-$(CONFIG_MIPS_GT96100ETH) += gt96100eth.o
obj-$(CONFIG_MIPS_AU1X00_ENET) += au1000_eth.o
obj-$(CONFIG_MIPS_SIM_NET) += mipsnet.o
obj-$(CONFIG_SGI_IOC3_ETH) += ioc3-eth.o
obj-$(CONFIG_DECLANCE) += declance.o
obj-$(CONFIG_ATARILANCE) += atarilance.o
obj-$(CONFIG_ATARI_BIONET) += atari_bionet.o
obj-$(CONFIG_ATARI_PAMSNET) += atari_pamsnet.o
obj-$(CONFIG_A2065) += a2065.o
obj-$(CONFIG_HYDRA) += hydra.o 8390.o
obj-$(CONFIG_ARIADNE) += ariadne.o
obj-$(CONFIG_CS89x0) += cs89x0.o
obj-$(CONFIG_MACSONIC) += macsonic.o
obj-$(CONFIG_MACMACE) += macmace.o
obj-$(CONFIG_MAC89x0) += mac89x0.o
obj-$(CONFIG_TUN) += tun.o
obj-$(CONFIG_DL2K) += dl2k.o
obj-$(CONFIG_R8169) += r8169.o
obj-$(CONFIG_AMD8111_ETH) += amd8111e.o
obj-$(CONFIG_IBMVETH) += ibmveth.o
obj-$(CONFIG_S2IO) += s2io.o
obj-$(CONFIG_SMC91X) += smc91x.o
obj-$(CONFIG_DM9000) += dm9000.o
obj-$(CONFIG_FEC_8XX) += fec_8xx/

obj-$(CONFIG_ARM) += arm/
obj-$(CONFIG_DEV_APPLETALK) += appletalk/
obj-$(CONFIG_TR) += tokenring/
obj-$(CONFIG_WAN) += wan/
obj-$(CONFIG_ARCNET) += arcnet/
obj-$(CONFIG_NET_PCMCIA) += pcmcia/
obj-$(CONFIG_NET_RADIO) += wireless/
obj-$(CONFIG_NET_TULIP) += tulip/
obj-$(CONFIG_HAMRADIO) += hamradio/
obj-$(CONFIG_IRDA) += irda/
obj-$(CONFIG_ETRAX_ETHERNET) += cris/
obj-$(CONFIG_ENP2611_MSF_NET) += ixp2000/

obj-$(CONFIG_NDISWRAPPER) += ndiswrapper/
obj-$(CONFIG_NETCONSOLE) += netconsole.o

obj-$(CONFIG_FS_ENET) += fs_enet/

=== scripts/package/Makefile ===
# Makefile for the different targets used to generate full packages of a kernel
# It uses the generic clean infrastructure of kbuild

# Ignore the following files/directories during tar operation
TAR_IGNORE := --exclude SCCS --exclude BitKeeper --exclude .svn --exclude CVS


# RPM target
# ---------------------------------------------------------------------------
# The rpm target generates two rpm files:
# /usr/src/packages/SRPMS/kernel-2.6.7rc2-1.src.rpm
# /usr/src/packages/RPMS/i386/kernel-2.6.7rc2-1.<arch>.rpm
# The src.rpm files includes all source for the kernel being built
# The <arch>.rpm includes kernel configuration, modules etc.
#
# Process to create the rpm files
# a) clean the kernel
# b) Generate .spec file
# c) Build a tar ball, using symlink to make kernel version
#    first entry in the path
# d) and pack the result to a tar.gz file
# e) generate the rpm files, based on kernel.spec
# - Use /. to avoid tar packing just the symlink

# Do we have rpmbuild, otherwise fall back to the older rpm
RPM := $(shell if [ -x "/usr/bin/rpmbuild" ]; then echo rpmbuild; \
	           else echo rpm; fi)

# Remove hyphens since they have special meaning in RPM filenames
KERNELPATH := kernel-$(subst -,,$(KERNELRELEASE))
MKSPEC     := $(srctree)/scripts/package/mkspec
PREV       := set -e; cd ..;

# rpm-pkg
.PHONY: rpm-pkg rpm

$(objtree)/kernel.spec: $(MKSPEC) $(srctree)/Makefile
	$(CONFIG_SHELL) $(MKSPEC) > $@

rpm-pkg rpm: $(objtree)/kernel.spec
	$(MAKE) clean
	$(PREV) ln -sf $(srctree) $(KERNELPATH)
	$(PREV) tar -cz $(RCS_TAR_IGNORE) -f $(KERNELPATH).tar.gz $(KERNELPATH)/.
	$(PREV) rm $(KERNELPATH)

	set -e; \
	$(CONFIG_SHELL) $(srctree)/scripts/mkversion > $(objtree)/.tmp_version
	set -e; \
	mv -f $(objtree)/.tmp_version $(objtree)/.version

	$(RPM) --target $(UTS_MACHINE) -ta ../$(KERNELPATH).tar.gz
	rm ../$(KERNELPATH).tar.gz

clean-files := $(objtree)/kernel.spec

# binrpm-pkg
.PHONY: binrpm-pkg
$(objtree)/binkernel.spec: $(MKSPEC) $(srctree)/Makefile
	$(CONFIG_SHELL) $(MKSPEC) prebuilt > $@
	
binrpm-pkg: $(objtree)/binkernel.spec
	$(MAKE) KBUILD_SRC=
	set -e; \
	$(CONFIG_SHELL) $(srctree)/scripts/mkversion > $(objtree)/.tmp_version
	set -e; \
	mv -f $(objtree)/.tmp_version $(objtree)/.version

	$(RPM) --define "_builddir $(srctree)" --target $(UTS_MACHINE) -bb $<

clean-files += $(objtree)/binkernel.spec

# Deb target
# ---------------------------------------------------------------------------
#
.PHONY: deb-pkg
deb-pkg:
	$(MAKE) KBUILD_SRC=
	$(CONFIG_SHELL) $(srctree)/scripts/package/builddeb

#clean-dirs += $(objtree)/debian/


# tarball targets
# ---------------------------------------------------------------------------
.PHONY: tar%pkg
tar%pkg:
	$(MAKE) KBUILD_SRC=
	$(CONFIG_SHELL) $(srctree)/scripts/package/buildtar $@

clean-dirs += $(objtree)/tar-install/


# Help text displayed when executing 'make help'
# ---------------------------------------------------------------------------
help:
	@echo '  rpm-pkg         - Build the kernel as an RPM package'
	@echo '  binrpm-pkg      - Build an rpm package containing the compiled kernel'
	@echo '                    and modules'
	@echo '  deb-pkg         - Build the kernel as an deb package'
	@echo '  tar-pkg         - Build the kernel as an uncompressed tarball'
	@echo '  targz-pkg       - Build the kernel as a gzip compressed tarball'
	@echo '  tarbz2-pkg      - Build the kernel as a bzip2 compressed tarball'

=== drivers/net/ndiswrapper/Makefile ===
OBJS := hal.o iw_ndis.o loader.o misc_funcs.o ndis.o ntoskernel.o \
	ntoskernel_io.o pe_linker.o proc.o usb.o wrapper.o pnp.o \
	wrapndis.o wrapmem.o

CFLAGS += -DDRIVER_VERSION=\"1.22\" -freg-struct-return

ifeq ($(CONFIG_X86_64),y)
OBJS += win2lin_stubs.o
else
OBJS += divdi3.o
endif

obj-$(CONFIG_NDISWRAPPER) := ndiswrapper.o
ndiswrapper-objs := $(OBJS)


targets :=	win2lin_stubs.h		\
		hal_exports.h 		\
		misc_funcs_exports.h 	\
		ndis_exports.h 		\
		ntoskernel_exports.h 	\
		usb_exports.h 		\
		wrapper_exports.h	\
		ntoskernel_io_exports.h


$(obj)/win2lin_stubs.o: $(obj)/win2lin_stubs.h $(src)/win2lin_stubs.S
$(obj)/win2lin_stubs.h: $(src)/hal.c $(src)/misc_funcs.c $(src)/ndis.c \
		$(src)/ntoskernel.c $(src)/ntoskernel_io.c $(src)/pnp.c \
		$(src)/wrapndis.c $(src)/usb.c
	@for file in $^; do \
		echo; \
		echo "# automatically generated from $$file"; \
		sed -n \
			-e 's/.*WIN_FUNC(\([^\,]\+\) *\, *\([0-9]\+\)).*/\
			   win2lin(\1, \2)/p'   \
			-e 's/.*WIN_FUNC_PTR(\([^\,]\+\) *\, *\([0-9]\+\)).*/\
			   win2lin(\1, \2)/p'   \
			$$file | sed -e 's/[ \t      ]\+//' | sort -u; \
	done > $@


$(obj)/hal.o: $(obj)/hal_exports.h
$(obj)/hal_exports.h: $(src)/hal.c

$(obj)/misc_funcs.o: $(obj)/misc_funcs_exports.h
$(obj)/misc_funcs_exports.h: $(src)/misc_funcs.c

$(obj)/ndis.o: $(obj)/ndis_exports.h
$(obj)/ndis_exports.h: $(src)/ndis.c

$(obj)/ntoskernel.o: $(obj)/ntoskernel_exports.h
$(obj)/ntoskernel_exports.h: $(src)/ntoskernel.c

$(obj)/usb.o: $(obj)/usb_exports.h
$(obj)/usb_exports.h: $(src)/usb.c

$(obj)/wrapper.o: $(obj)/wrapper_exports.h
$(obj)/wrapper_exports.h: $(src)/wrapper.c

$(obj)/ntoskernel_io.o: $(obj)/ntoskernel_io_exports.h
$(obj)/ntoskernel_io_exports.h: $(src)/ntoskernel_io.c


quiet_cmd_exports = EXPORTS $@
      cmd_exports = \
        ( \
                echo "/* automatically generated from $< */"; \
                echo '\#ifdef CONFIG_X86_64'; \
                sed -n \
                        -e 's/.*WIN_FUNC(\([^\,]\+\) *\, *\([0-9]\+\)).*/WIN_FUNC_DECL(\1, \2)/p' \
                        -e 's/.*WIN_FUNC_PTR(\([^\,]\+\) *\, *\([0-9]\+\)).*/WIN_FUNC_DECL(\1, \2)/p' \
                   $< | sed -e 's/[ \t  ]\+//' | sort -u; \
                echo '\#endif'; \
                echo "struct wrap_export $(shell basename $< .c)_exports[] = {";\
                sed -n \
                        -e 's/.*WIN_FUNC(_win_\([^\,]\+\) *\, *\([0-9]\+\)).*/WIN_WIN_SYMBOL(\1,\2),/p' \
                        -e 's/.*WIN_FUNC(\([^\,]\+\) *\, *\([0-9]\+\)).*/WIN_SYMBOL(\1,\2),/p' \
                        -e 's/.*WIN_SYMBOL_MAP(\("[^"]\+"\)[ ,\]\+\([^)]\+\)).*/{\1,(generic_func)\2},/p'  \
                           $< | sed -e 's/[ \t  ]*/   /' | sort -u; \
                echo '   {NULL, NULL}'; \
                echo '};'; \
        ) > $@

$(obj)/%_exports.h: $(src)/%.c FORCE
	$(call if_changed,exports)

=== drivers/net/wireless/Makefile ===
#
# Makefile for the Linux Wireless network device drivers.
#

obj-$(CONFIG_IPW2100) += ipw2100.o

obj-$(CONFIG_IPW2200) += ipw2200.o

obj-$(CONFIG_STRIP) += strip.o
obj-$(CONFIG_ARLAN) += arlan.o 

arlan-objs := arlan-main.o arlan-proc.o

# Obsolete cards
obj-$(CONFIG_WAVELAN)		+= wavelan.o
obj-$(CONFIG_PCMCIA_NETWAVE)	+= netwave_cs.o
obj-$(CONFIG_PCMCIA_WAVELAN)	+= wavelan_cs.o

obj-$(CONFIG_HERMES)		+= orinoco.o hermes.o
obj-$(CONFIG_PCMCIA_HERMES)	+= orinoco_cs.o
obj-$(CONFIG_APPLE_AIRPORT)	+= airport.o
obj-$(CONFIG_PLX_HERMES)	+= orinoco_plx.o
obj-$(CONFIG_PCI_HERMES)	+= orinoco_pci.o
obj-$(CONFIG_TMD_HERMES)	+= orinoco_tmd.o
obj-$(CONFIG_NORTEL_HERMES)	+= orinoco_nortel.o
obj-$(CONFIG_PCMCIA_SPECTRUM)	+= spectrum_cs.o

obj-$(CONFIG_AIRO)		+= airo.o
obj-$(CONFIG_AIRO_CS)		+= airo_cs.o airo.o

obj-$(CONFIG_ATMEL)             += atmel.o
obj-$(CONFIG_PCI_ATMEL)         += atmel_pci.o 
obj-$(CONFIG_PCMCIA_ATMEL)      += atmel_cs.o

obj-$(CONFIG_PRISM54)		+= prism54/

obj-$(CONFIG_HOSTAP)		+= hostap/
obj-$(CONFIG_BCM43XX)           += bcm43xx/
obj-$(CONFIG_ZD1211RW)          += zd1211rw/

obj-$(CONFIG_ADM8211)           += adm8211/
obj-$(CONFIG_NET_ACX)           += acx/
obj-$(CONFIG_NET_RTL818X)       += rtl818x/ rtl_ieee80211/
obj-$(CONFIG_NET_RTL8187)       += rtl8187/ rtl_ieee80211/
obj-$(CONFIG_RT_EXP)            += rt2x00/

obj-$(CONFIG_RT2400_LEGACY)     += rt2x00-legacy/rt2400/
obj-$(CONFIG_RT2500_LEGACY)     += rt2x00-legacy/rt2500/
obj-$(CONFIG_RT2570_LEGACY)     += rt2x00-legacy/rt2570/


# 16-bit wireless PCMCIA client drivers
obj-$(CONFIG_PCMCIA_RAYCS)	+= ray_cs.o
obj-$(CONFIG_PCMCIA_WL3501)	+= wl3501_cs.o

=== drivers/net/wireless/rt2x00/Makefile ===
80211-objs := \
	ieee80211/ieee80211.o \
	ieee80211/ieee80211_ioctl.o \
	ieee80211/sta_info.o \
	ieee80211/wep.o \
	ieee80211/wpa.o \
	ieee80211/ieee80211_proc.o \
	ieee80211/ieee80211_scan.o \
	ieee80211/ieee80211_sta.o \
	ieee80211/ieee80211_dev.o \
	ieee80211/ieee80211_iface.o \
	ieee80211/ieee80211_sysfs.o \
	ieee80211/michael.o \
	ieee80211/tkip.o \
	ieee80211/aes_ccm.o \
	ieee80211/wme.o

ifeq ($(CONFIG_NET_SCHED),)
	80211-objs += ieee80211/fifo_qdisc.o
endif

rate_control-objs := ieee80211/rate_control.o
radiobtn-objs := radiobtn/radiobtn.o

obj-$(CONFIG_D80211)		+= 80211.o rate_control.o
obj-$(CONFIG_RADIOBTN)		+= radiobtn.o
obj-$(CONFIG_RT2400PCI)		+= rt2400pci.o
obj-$(CONFIG_RT2500PCI)		+= rt2500pci.o
obj-$(CONFIG_RT2500USB)		+= rt2500usb.o
obj-$(CONFIG_RT61PCI)		+= rt61pci.o
obj-$(CONFIG_RT73USB)		+= rt73usb.o

EXTRA_CFLAGS += -I$(src)/ieee80211 -I$(src)/radiobtn/linux \
	-include $(srctree)/$(src)/rt2x00_compat.h

=== drivers/net/wireless/rtl_ieee80211/Makefile ===
ieee80211-rtl-objs = rtl_ieee80211_softmac.o rtl_ieee80211_rx.o rtl_ieee80211_tx.o rtl_ieee80211_wx.o rtl_ieee80211_module.o rtl_ieee80211_softmac_wx.o rtl_ieee80211_crypt.o rtl_ieee80211_crypt_tkip.o rtl_ieee80211_crypt_ccmp.o rtl_ieee80211_crypt_wep.o

obj-m += ieee80211-rtl.o

=== drivers/net/wireless/rt2x00-legacy/rt2500/Makefile ===
MODULE_NAME := rt2500

RESMAN_CORE_OBJS := rtmp_main.o
RESMAN_GLUE_OBJS := mlme.o connect.o sync.o assoc.o auth.o auth_rsp.o rtmp_data.o rtmp_init.o sanity.o rtmp_wep.o wpa.o md5.o rtmp_tkip.o rtmp_info.o eeprom.o

$(MODULE_NAME)-objs := $(RESMAN_CORE_OBJS) $(RESMAN_GLUE_OBJS)

obj-$(CONFIG_RT2500_LEGACY) += $(MODULE_NAME).o

=== drivers/net/wireless/rt2x00-legacy/rt2570/Makefile ===
MODULE_NAME := rt2570

RESMAN_CORE_OBJS := rtusb_main.o
RESMAN_GLUE_OBJS := mlme.o rtusb_bulk.o connect.o sync.o rtusb_init.o rtmp_tkip.o wpa.o rtmp_wep.o rtusb_info.o assoc.o auth.o auth_rsp.o md5.o rtusb_io.o sanity.o rtusb_data.o

$(MODULE_NAME)-objs := $(RESMAN_CORE_OBJS) $(RESMAN_GLUE_OBJS)

obj-$(CONFIG_RT2570_LEGACY) += $(MODULE_NAME).o

=== debian/changelog ===
xen-source-2.6.16 (2.6.16-11.2) edgy; urgency=low

  * "The sweaty palms release".
  * Added xenu support.
  * Various fixes to xen-headers and amd64 fixes by Tolleff.

 -- Chuck Short <zulcss@ubuntu.com>  Sat, 16 Sep 2006 08:47:47 -0400

ixen-source-2.6.16 (2.6.16-11.1) edgy; urgency=low

  * Start stablization cycle:
    - Fix FBTFS.

 -- Chuck Short <zulcss@ubuntu.com>  Tue, 12 Sep 2006 11:43:37 -0400

xen-source-2.6.16 (2.6.16-11) edgy; urgency=low

  * Updated amd64-generic configs.
  * Fix FTBFS.

 -- Chuck Short <zulcss@ubuntu.com>  Mon, 11 Sep 2006 19:29:09 -0400

xen-source-2.6.16 (2.6.16-10) edgy; urgency=low

  * Updated to 2.6.16.29-rc1.
  * Updated to Xen snapshot 112412.
  * Added bd_claim patch from Tollef.
  * Removed 686, and k7, replaced by generic.
  * Removed amd64-k8, amd64-xeon replaced by amd64-generic.
  * Added support for ndiswrapper.
  * Added support for bcm43xx.
  * Added support for acx100.
  * Added support for rt2x00.
  * Added support for rt2x00-legacy
  * Added support for rtl8187.
  * Added support for rtl818x.
  * Added support for zd1211rw.
  * Fixed kernel headers.

 -- Chuck Short <zulcss@ubuntu.com>  Tue,  5 Sep 2006 21:41:25 -0400

xen-source-2.6.16 (2.6.16-9) edgy; urgency=low

  * Fix FTBFS.

 -- Chuck Short <zulcss@ubuntu.com>  Sun, 20 Aug 2006 10:47:07 -0400

xen-source-2.6.16 (2.6.16-8) edgy; urgency=low

  * Updated to latest and greatest stable tree.

 -- Chuck Short <zulcss@ubuntu.com>  Thu, 17 Aug 2006 08:17:47 -0400

xen-source-2.6.16 (2.6.16-7) edgy; urgency=low

  * Fix Typo. 

 -- Chuck Short <zulcss@ubuntu.com>  Sun, 13 Aug 2006 17:52:32 -0400

xen-source-2.6.16 (2.6.16-6) edgy; urgency=low

  * Fix FTBFS.

 -- Chuck Short <zulcss@ubuntu.com>  Tue,  8 Aug 2006 14:15:37 -0400

xen-source-2.6.16 (2.6.16-5) edgy; urgency=low

  * Added amd64 support.
     * Added generic, k8 and xeon flavours
  * Added k7 flavours.
  * Added firmware support.

 -- Chuck Short <zulcss@gmail.com>  Fri,  4 Aug 2006 21:32:07 -0400

xen-source-2.6.16 (2.6.16-4) edgy; urgency=low

  * Updated configs, set CONFIG_BLK_DEV_LOOP to module.

 -- Chuck Short <zulcss@ubuntu.com>  Mon, 31 Jul 2006 22:50:08 -0400

xen-source-2.6.16 (2.6.16-3) edgy; urgency=low

  * Fix another FTBFS.
  * Cleaned up debian/rules file.

 -- Chuck Short <zulcss@ubuntu.com>  Sun, 30 Jul 2006 12:15:53 +0000

xen-source-2.6.16 (2.6.16-2) edgy; iurgency=low

  * Fix FTBFS.
  * Added xen-doc-2.6.16 and xen-source-2.6.16.
  * Fixed typos in control file.
   

 -- Chuck Short <zulcss@ubuntu.com>  Sat, 29 Jul 2006 04:13:39 +0000

xen-source-2.6.16 (2.6.16-1) edgy; urgency=low

  This release was brought to you by the letter X.

  * Initial release.
    - Linux kernel based off of 2.6.16.27.
    - Xen snapshot is based off xen-unstable hg tree. Snapshot date
      is 20060724.
    - Kernel only supports x86 archictecture with the 686 in this
      release.
    - ABI detection has be temporarily removed.
    - This release does not provide 3rd party drivers, there are plans
      fo the future.
    - Please use mkinitramfs to generate an image for the XEN kernel.
    - Thanks to Ben Collins for the help and advice.

 -- Chuck Short <zulcss@ubuntu.com>  Fri, 23 Jun 2006 19:58:23 -0400

=== debian/control ===
Source: xen-source-2.6.16
Section: devel
Priority: optional
Maintainer: Chuck Short <zulcss@ubuntu.com>
Build-Depends: debhelper (>= 3), kernel-package (>= 10.049ubuntu2), module-init-tools, m4
Build-Depends-Indep: xmlto, docbook-utils, gs, transfig, bzip2, sharutils

Package: xen-source-2.6.16
Architecture: amd64 i386
Section: devel
Priority: optional
Provides: xen-source, xen-source-2.6
Depends: binutils, bzip2, coreutils | fileutils (>= 4.0)
Recommends: libc-dev, gcc, make
Suggests: libncurses-dev | ncurses-dev, kernel-package, libqt3-dev
Description: Linux kernel source for version 2.6.17 with Ubuntu patches
 This package provides the source code for the Linux kernel version 2.6.17.
 .
 You may configure the kernel to your setup by typing "make config" and
 following instructions, but you could get ncursesX.X-dev and try "make
 menuconfig" for a jazzier, and easier to use interface. There are options
 to use QT or GNOME based configuration interfaces, but they need
 additional packages to be installed. Also, please read the detailed
 documentation in the file
 /usr/share/doc/linux-source-2.6.17/README.headers.gz.
 .
 If you wish to use this package to create a custom Linux kernel, then it
 is suggested that you investigate the package kernel-package, which has
 been designed to ease the task of creating kernel image packages.
 .
 If you are simply trying to build third-party modules for your kernel,
 you do not want this package. Install the appropriate xen-headers
 package instead.

Package: xen-headers-2.6.16
Architecture: amd64 i386
Section: devel
Priority: optional
Depends: coreutils | fileutils (>= 4.0)
Provides: xen-headers, xen-headers-2.6
Description: Header files related to Linux kernel, specifically, version 2.6.16
 This package provides kernel header files for sites 
 that want the latest kernel headers for version 
 2.6.16
 Please read 
 /usr/share/doc/xen-headers-2.6.16/debian.README.gz
 for details

Package: xen-doc-2.6.16
Architecture: amd64 i386
Section: doc
Priority: optional
Provides: xenx-doc-2.6
Conflicts: xen-doc-2.6
Replaces: xen-doc-2.6
Depends: coreutils | fileutils (>= 4.0)
Description: Linux kernel specific documentation for version 2.6.16
 This package provides the various readme's in the 2.6.16 kernel
 Documentation/ subdirectory: these typically contain kernel-specific
 installation notes for some drivers for example. See
 /usr/share/doc/linux-doc-2.6.16/Documentation/00-INDEX for a list of what
 is contained in each file.  Please read the Changes file, as it contains
 information about the problems, which may result by upgrading your
 kernel.

Package: xen-headers-2.6.16-11.2-generic-xen0
Architecture: amd64 i386
Section: base
Priority: optional
Depends: coreutils | fileutils (>= 4.0), xen-headers-2.6.16, ${shlibs:Depends}
Provides: xen-headers-xen0, xen-headers-xen0-2.6
Description: Linux kernel headers 2.6.16 on xen
 This package provides kernel header files for version 2.6.15 on 386, for
 sites that want the latest kernel headers.  Please read
 /usr/share/doc/xen-headers-2.6.16-1-686/debian.README.gz for details.

Package: xen-image-xen0-2.6.16-11.2-generic
Architecture: amd64 i386
Section: base 
Priority: optional 
Provides: xen-image-xen0,  xen-image-xen0-2.6 
Depends:  initramfs-tools (>= 0.36ubuntu6), coreutils | fileutils (>= 4.0), module-init-tools (>= 3.2.2-3ubuntu2) 
Recommends: grub
Suggests: fdutils, xen-doc-2.6.16
Description: Linux xen kernel binary image for version 2.6.16 
 This package contains the Linux xen kernel image for version 2.6.16 
 and the modules built by the packager.

Package: xen-headers-2.6.16-11.2-generic-xenu
Architecture: amd64 i386
Section: base
Priority: optional
Depends: coreutils | fileutils (>= 4.0), xen-headers-2.6.16, ${shlibs:Depends}
Provides: xen-headers-xenu, xen-headers-xenu-2.6
Description: Linux kernel headers 2.6.16 on xen
 This package provides kernel header files for version 2.6.15 on 386, for
 sites that want the latest kernel headers.  Please read
 /usr/share/doc/xen-headers-2.6.16-1-686/debian.README.gz for details.

Package: xen-image-xenu-2.6.16-11.2-generic
Architecture: amd64 i386
Section: base
Priority: optional
Provides: xen-image-xenu,  xen-image-xenu-2.6
Depends:  initramfs-tools (>= 0.36ubuntu6), coreutils | fileutils (>= 4.0), module-init-tools (>= 3.2.2-3ubuntu2)
Recommends: grub
Suggests: fdutils, xen-doc-2.6.16
Description: Linux xen kernel binary image for version 2.6.16
 This package contains the Linux xen kernel image for version 2.6.16
 and the modules built by the packager.

=== debian/rules ===
#!/usr/bin/make -f
#
# debian/rules for kernel-source.
#
# GNU copyright 1997 to 1999 by Joey Hess.
# Copyright (c) 1999-2002 Herbert Xu <herbert@debian.org>
# Copyright (c) 2004 Jens Schmalzing <jensen@debian.org>
#

# This is the debhelper compatability version to use.
export DH_COMPAT=4

SHELL := sh -e

stem := xen

# extract the upstream release and the full package version from the changelog
release	:= $(shell sed -n '1s/^.*(\(.*\)-.*).*$$/\1/p' debian/changelog)

# extract the version from the package name that can be different from release
pkgversion := $(shell sed -n '1s/^$(stem)-source-\([^ ]*\) .*/\1/p' debian/changelog)

# extract all the Debian revisions for this release from the changelog
revisions := $(shell sed -n 's/^$(stem)-source-$(pkgversion)\ .*($(release)-\(.*\)).*$$/\1/p' debian/changelog | tac)

# set the current Debian revision to the latest by default;
# note that for some targets, the two may actually be different.
revision ?= $(word $(words $(revisions)),$(revisions))

# Get the previously built revision; we compare ABIs with that.  If no 
# previous revision, default to 0.
prev_revisions := $(filter-out $(revision),0 $(revisions))
prev_revision := $(word $(words $(prev_revisions)),$(prev_revisions))

abidir := $(CURDIR)/debian/abi
skipabi := false

version.Debian: 
	echo $(pkgversion) > $@

release.Debian:
	echo $(release)-$(revision) > $@

# how we call ourselves recursively
# RECURSION = $(MAKE) -f debian/rules

gitver=$(shell if test -f .git/HEAD; then cat .git/HEAD; else echo ""; fi)
gitverpre=$(shell echo $(gitver) | cut -b -3)
gitverpost=$(shell echo $(gitver) | cut -b 30-32)

autobuild=$(shell if [ "$$AUTOBUILD" = "" ]; then echo n; else echo y; fi)

export version := 2.6.16
export debnum := -11.2
export abinum := 11.2

DEB_HOST_GNU_CPU := $(shell dpkg-architecture -qDEB_HOST_GNU_CPU)
DEB_HOST_ARCH := $(shell dpkg-architecture -qDEB_HOST_ARCH)

basedir := $(CURDIR)/debian/config/$(DEB_HOST_ARCH)

flavours := $(shell find $(basedir) -maxdepth 1 -type f ! -name default -printf '%f\n' \
)

builddir := $(CURDIR)/debian/build
srcdir := $(builddir)/$(stem)-source-$(version)

export DEBIAN_SRCTOP := $(srcdir)
export DEBIAN_UPSTREAM_VERSION := $(version)
export DEBIAN_STEM := $(stem)

export UBUNTUBUILD=1

ifeq ($(strip $(DEB_HOST_ARCH)),powerpc)
subarch := --subarch pmac
endif

MAKE_KPKG := make-kpkg --stem $(stem) --arch $(DEB_HOST_ARCH)

# temporary workarounds for now
XEN_HEADERS := xen-headers-$(version)-$(abinum)
XEN_HEADERS_DIR := $(CURDIR)/debian/$(XEN_HEADERS)
XEN_KERNEL_HEADERS := xen-headers-$(pkgversion)
XEN_KERNEL_HEADERS_DIR := $(CURDIR)/debian/$(XEN_KERNEL_HEADERS)

XEN_DOC := xen-doc-$(pkgversion)
XEN_DOC_DIR := $(CURDIR)/debian/$(XEN_DOC)/usr/share/doc/$(XEN_DOC)

XEN_SOURCE := xen-source-$(pkgversion)
XEN_SOURCE_DIR := $(CURDIR)/debian/$(XEN_SOURCE)/usr/src/

unpack: stamp-unpack
stamp-unpack:
	dh_testdir
	find . \( -path ./debian -o -path ./.git -o -name .gitignore \) -prune -o -print | \
		cpio -dumpl $(srcdir)
	cd $(srcdir); rm -f stamp-* version.Debian release.Debian
	mkdir -p $(srcdir)/debian
	cp debian/changelog $(srcdir)/debian
	cp debian/control $(srcdir)/debian
	cp debian/copyright $(srcdir)/debian
	> $(srcdir)/debian/official
	install -D -m755 debian/post-install $(srcdir)/debian/post-install
	chmod u+x debian/header-install
	ln -s ../../../firmware $(srcdir)/debian
	for i in $(flavours); do \
		echo "$$i"; \
		cp -al $(srcdir) $(builddir)/build-$$i; \
		rm -f $(builddir)/build-$$i/.config; \
		cat $(basedir)/$$i >> $(builddir)/build-$$i/.config; \
	done

	touch stamp-unpack

build_prereq := \
	release.Debian version.Debian \
	unpack \

build: $(build_prereq)
	dh_testdir

	PATH=$$PWD/debian/bin:$$PATH; \
	export HARCH=$$(grep "^headers-$(DEB_HOST_ARCH)[[:space:]]" debian/config/archmap | grep -v ^# | awk '{print $$2}'); \
	cd $(srcdir); \
		make ARCH=$$HARCH defconfig; \
		mv .config .config.old; \
		sed 's/^# \(CONFIG_MODVERSIONS\) is not set$$/\1=y/' \
			.config.old > .config; \
		make ARCH=$$HARCH prepare


	for i in $(flavours); do \
		#export KPKG_ARCH=$$(grep "^$$i[[:space:]]" debian/config/archmap | grep -v ^# | awk '{print $$2}'); \
		cd $(builddir)/build-$$i; \
		if [ -e /CurrentlyBuilding ] && [ -z "$(CONCURRENCY_LEVEL)" ]; then \
			CONCURRENCY_LEVEL=$$(getconf _NPROCESSORS_ONLN) && \
			CONCURRENCY_LEVEL=$$(expr $$CONCURRENCY_LEVEL \* 2) && \
			export CONCURRENCY_LEVEL; \
		fi; \
		$(MAKE_KPKG) --subarch xen --append_to_version $(debnum)-generic \
			build; \
		cd - > /dev/null; \
	done

	touch build-stamp

clean: debian/control
	dh_testdir
	dh_testroot

	$(MAKE_KPKG) clean
	rm -f stamp-* .config* release.Debian version.Debian
	rm -rf $(builddir)
	rm -rf xen-*

	dh_clean

	# udebs/kernel-wedge
	rm -rf TODO firmware modules kernel-versions package-list 


install: build
	dh_testdir
	dh_testroot
	dh_clean -k
	dh_installdirs

	> debian/files

# Build architecture-independent files here.
binary-indep: build install xen-docs xen-source
	dh_testdir
	dh_testroot

# Build architecture-dependent files here.
binary-debs: install
	dh_testdir
	dh_testroot

	export KPKG_ARCH=$$(grep "^headers-$(DEB_HOST_ARCH)[[:space:]]" debian/config/archmap | grep -v ^# | awk '{print $$3}'); \
	cd $(srcdir); \

	for i in $(flavours); do \
		export KPKG_ARCH=$$(grep "^$$i[[:space:]]" debian/config/archmap | grep -v ^# | awk '{print $$2}'); \
		cp -al $(builddir)/build-$$i $(builddir)/install-$$i; \
		cd $(builddir)/install-$$i; \
		$(MAKE_KPKG) --subarch xen --append_to_version $(debnum)-generic --initrd kernel-image; \
		cd - > /dev/null; \
		cat $(builddir)/install-$$i/debian/files >> debian/files; \
		#rm -rf $(builddir)/install-$$i; \
	done

xen-headers: install
	dh_testdir
	dh_testroot

	for i in $(flavours); do \
		mkdir -p $(XEN_HEADERS_DIR)-$$i/usr/src/$(XEN_HEADERS)-$$i; \
		cd $(builddir)/install-$$i; \
		for d in arch block crypto drivers firmware fs init ipc kernel lib mm modules net security sound usr xen; do \
		ln -s ../$(XEN_KERNEL_HEADERS)/$$d $(XEN_HEADERS_DIR)-$$i/usr/src/$(XEN_HEADERS)-$$i/ ; \
		done ; \
		cp -rp scripts Makefile .config $(XEN_HEADERS_DIR)-$$i/usr/src/$(XEN_HEADERS)-$$i; \
		mkdir $(XEN_HEADERS_DIR)-$$i/usr/src/$(XEN_HEADERS)-$$i/include;\
		for d in include/*; do \
			ln -s ../../$(XEN_KERNEL_HEADERS)/$$d $(XEN_HEADERS_DIR)-$$i/usr/src/$(XEN_HEADERS)-$$i/include/ ; \
		done ; \
		for d in asm config linux; do \
			rm $(XEN_HEADERS_DIR)-$$i/usr/src/$(XEN_HEADERS)-$$i/include/$$d ; \
		done ; \
		cp -rp include/asm include/config include/linux $(XEN_HEADERS_DIR)-$$i/usr/src/$(XEN_HEADERS)-$$i/include ; \
	done

	for j in $(flavours); do \
		dh_installchangelogs -p$(XEN_HEADERS)-$$j; \
		dh_installdocs -p$(XEN__HEADERS)-$$j; \
		dh_compress -p$(XEN_HEADERS)-$$j; \
		dh_fixperms -p$(XEN_HEADERS)-$$j; \
		dh_installdeb -p$(XEN_HEADERS)-$$j; \
		dh_gencontrol -p$(XEN_HEADERS)-$$j; \
		dh_md5sums -p$(XEN_HEADERS)-$$j; \
		dh_builddeb -p$(XEN_HEADERS)-$$j; \
        done


xen-kernel-headers: install
	dh_testdir
	dh_testroot

	mkdir -p $(XEN_KERNEL_HEADERS_DIR)/usr/src/$(XEN_KERNEL_HEADERS)
	cd $(srcdir); \
        ( \
          find . \
            -path './Documentation/*' -prune -o \
            -path './arch/*' -prune -o \
            -path './include/asm*' -prune -o \
            -path './scripts/*' -prune -o \
            -path './include/*' -print -o \
            \( -name 'Makefile*' -o -name 'Kconfig*' -o -name 'Rules.make' \) -print; \
          find include/asm-generic -print; \
          for i in $(DEB_HOST_GNU_CPU); do \
            find arch/$$i \
              \( -name 'Makefile*' -o -name 'Kconfig*' -o -name 'Rules.make' \) -print; \
            find include/asm-* -print; \
          done; \
        ) \
        | \
	cpio -pd --preserve-modification-time $(XEN_KERNEL_HEADERS_DIR)/usr/src/$(XEN_KERNEL_HEADERS)

	dh_installchangelogs -p$(XEN_KERNEL_HEADERS)
	dh_installdocs  -p$(XEN_KERNEL_HEADERS)
	dh_compress -p$(XEN_KERNEL_HEADERS)
